<template>
  <div>
    <no-ssr>
      <MapContainer @ready="loadMap" />
    </no-ssr>
    <SoundButton
      ref="soundButton"
      :src="music"
      :loop="true"
      :autoplay="true"
      class="btn music-button"
    />
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex'
import SoundButton from 'vue-howler-button/src/components/SoundButton.vue'
import MapContainer from '~/components/map-container-helper'

const storeModules = {
  map: createNamespacedHelpers('map'),
  player: createNamespacedHelpers('player')
}

export default {
  name: 'ShadowWorld',

  components: {
    MapContainer,
    SoundButton
  },

  computed: {
    ...storeModules.map.mapState(['shadowMapFilePath']),
    ...storeModules.map.mapGetters(['hasOverlay']),

    music() {
      const baseUrl = this.$router.options.base
      return ['music/shadow-world.ogg', 'music/shadow-world.mp3'].map(
        url => baseUrl + url
      )
    }
  },

  mounted() {
    document.addEventListener('keyup', this.onKeyUp)
  },

  beforeDestroy() {
    document.removeEventListener('keyup', this.onKeyUp)
    this.$refs.soundButton.howl.stop()
  },

  methods: {
    ...storeModules.map.mapActions(['setMapFilePath']),
    ...storeModules.player.mapActions(['setCharacterName']),

    loadMap() {
      this.setCharacterName('shadow').then(() =>
        this.setMapFilePath(this.shadowMapFilePath)
      )
    },

    onKeyUp({ key }) {
      if (key === 't' && !this.hasOverlay) {
        this.$router.push('/light-world')
      }
    }
  }
}
</script>
